//
// Created by danii on 22.09.2022.
//
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll sum_on_interval(ll left, ll right) {
    if (right < left) {
        return 0;
    }
    return right * (right + 1) / 2 - left * (left - 1) / 2;
}


int main() {
    int n, k;
    cin >> n >> k;

    vector<int> a (n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    if (n == 1) {
        cout << sum_on_interval(max(0, a[0] - k + 1), a[0]) << '\n';
        exit(0);
    }

    int max1 = -1, max2 = -1;
    for (int i = 0; i < n; i++) {
        if (a[i] > max1) {
            max2 = max1;
            max1 = a[i];
        } else if (a[i] > max2) {
            max2 = a[i];
        }
    }

    int len = max1 - max2 + 1;
    ll cycle_sum = sum_on_interval(max2, max1);

    cout << cycle_sum * (k / len) + sum_on_interval(max1 - k % len + 1, max1) << '\n';
    return 0;
}
