#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair <T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector <T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

void leave_unique(vector<int> &v) {
    sort(all(v));
    auto last = unique(all(v));
    v.resize(last - v.begin());
}

int main() {

    in(int, m)
    int n = m / 2;
    vector<pii> ex(m);
    cin >> ex;

    vector<int> h, w;
    for (auto const &p : ex) {
        h.push_back(p.first);
        w.push_back(p.second);
    }
    leave_unique(h);
    leave_unique(w);

    int ans = 0;
    for (int top : h) {
        for (int right : w) {
            int count = 0;
            bool top_hit = false, right_hit = false;
            for (auto const &p : ex) {
                if (p.first <= top && p.second <= right) {
                    count++;
                    if (p.first == top) top_hit = true;
                    if (p.second == right) right_hit = true;
                }
            }
            if (count == n && top_hit && right_hit) {
                ans++;
            }
        }
    }

    cout << ans << '\n';

}